<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-347"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FKeyboardManager%2FXHXTextKeyboardManager.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/KeyboardManager/XHXTextKeyboardManager.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_eb9f6304be17a12e3b483b042ed3323c.html">KeyboardManager</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">XHXTextKeyboardManager.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_x_h_x_text_keyboard_manager_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  XHXKeyboardManager.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  KKLOnlineHD</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by Leovir on 2018/2/28.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2018年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_x_h_x_text_keyboard_manager_8h.html">XHXTextKeyboardManager.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp;<span class="preprocessor">#import &lt;objc/runtime.h&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp; </div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#ad62ac520d11f2b28c8607820afd9065c">   13</a></span>&nbsp;BOOL <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ad62ac520d11f2b28c8607820afd9065c">XHXTextIsAppExtension</a>() {</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp;    <span class="keyword">static</span> BOOL isAppExtension = NO;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;    <span class="keyword">static</span> dispatch_once_t onceToken;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp;    dispatch_once(&amp;onceToken, ^{</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp;        Class cls = NSClassFromString(<span class="stringliteral">@&#34;UIApplication&#34;</span>);</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;        <span class="keywordflow">if</span>(!cls || ![cls respondsToSelector:<span class="keyword">@selector</span>(sharedApplication)]) isAppExtension = YES;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;        <span class="keywordflow">if</span> ([[[NSBundle mainBundle] bundlePath] hasSuffix:<span class="stringliteral">@&#34;.appex&#34;</span>]) isAppExtension = YES;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;    });</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;    <span class="keywordflow">return</span> isAppExtension;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;}</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#a7b31e4b1b1d2e323054fe61a1088a6d0">   24</a></span>&nbsp;UIApplication *<a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a7b31e4b1b1d2e323054fe61a1088a6d0">XHXTextSharedApplication</a>() {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;<span class="preprocessor">#pragma clang diagnostic push</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;<span class="preprocessor">#pragma clang diagnostic ignored &#34;-Wundeclared-selector&#34;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;    <span class="keywordflow">return</span> <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ad62ac520d11f2b28c8607820afd9065c">XHXTextIsAppExtension</a>() ? nil : [UIApplication performSelector:@selector(sharedApplication)];</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;<span class="preprocessor">#pragma clang diagnostic pop</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;}</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;<span class="keyword">static</span> <span class="keywordtype">int</span> _XHXTextKeyboardViewFrameObserverKey;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp; </div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="interface___x_h_x_text_keyboard_view_frame_observer.html">   35</a></span>&nbsp;<span class="keyword">@interface </span><a class="code" href="interface___x_h_x_text_keyboard_view_frame_observer.html">_XHXTextKeyboardViewFrameObserver</a> : NSObject</div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="interface___x_h_x_text_keyboard_view_frame_observer.html#af90bbd1510cb2260c646f18c4015ebac">   36</a></span>&nbsp;<span class="keyword">@property</span> (nonatomic, copy) <span class="keywordtype">void</span> (^<a class="code" href="interface___x_h_x_text_keyboard_view_frame_observer.html#a595de510eb2e5218fc4f387e8a7df2a0">notifyBlock</a>)(UIView *keyboard);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;- (void)addToKeyboardView:(UIView *)keyboardView;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;+ (instancetype)observerForView:(UIView *)keyboardView;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;<span class="keyword">@end</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="interface___x_h_x_text_keyboard_view_frame_observer.html">_XHXTextKeyboardViewFrameObserver</a> {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;    __unsafe_unretained UIView *_keyboardView;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;}</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;- (void)addToKeyboardView:(UIView *)keyboardView {</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;    <span class="keywordflow">if</span> (_keyboardView == keyboardView) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;    <span class="keywordflow">if</span> (_keyboardView) {</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;        [<span class="keyword">self</span> removeFrameObserver];</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;        objc_setAssociatedObject(_keyboardView, &amp;_XHXTextKeyboardViewFrameObserverKey, nil, OBJC_ASSOCIATION_RETAIN_NONATOMIC);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;    }</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;    _keyboardView = keyboardView;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;    <span class="keywordflow">if</span> (keyboardView) {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;        [<span class="keyword">self</span> addFrameObserver];</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;    }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;    objc_setAssociatedObject(keyboardView, &amp;_XHXTextKeyboardViewFrameObserverKey, <span class="keyword">self</span>, OBJC_ASSOCIATION_RETAIN_NONATOMIC);</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;}</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;- (void)removeFrameObserver {</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;    [_keyboardView removeObserver:self forKeyPath:@&#34;frame&#34;];</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp;    [_keyboardView removeObserver:self forKeyPath:@&#34;center&#34;];</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&nbsp;    [_keyboardView removeObserver:self forKeyPath:@&#34;bounds&#34;];</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&nbsp;    [_keyboardView removeObserver:self forKeyPath:@&#34;transform&#34;];</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&nbsp;    _keyboardView = nil;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&nbsp;}</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&nbsp;- (void)addFrameObserver {</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&nbsp;    <span class="keywordflow">if</span> (!_keyboardView) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&nbsp;    [_keyboardView addObserver:self forKeyPath:@&#34;frame&#34; options:kNilOptions context:NULL];</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&nbsp;    [_keyboardView addObserver:self forKeyPath:@&#34;center&#34; options:kNilOptions context:NULL];</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&nbsp;    [_keyboardView addObserver:self forKeyPath:@&#34;bounds&#34; options:kNilOptions context:NULL];</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&nbsp;    [_keyboardView addObserver:self forKeyPath:@&#34;transform&#34; options:kNilOptions context:NULL];</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&nbsp;}</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&nbsp; </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&nbsp;- (void)dealloc {</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&nbsp;    [<span class="keyword">self</span> removeFrameObserver];</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&nbsp;}</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&nbsp; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&nbsp;+ (instancetype)observerForView:(UIView *)keyboardView {</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&nbsp;    <span class="keywordflow">if</span> (!keyboardView) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&nbsp;    <span class="keywordflow">return</span> objc_getAssociatedObject(keyboardView, &amp;_XHXTextKeyboardViewFrameObserverKey);</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&nbsp;}</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&nbsp; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&nbsp;- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)<span class="keywordtype">object</span> change:(NSDictionary *)change context:(<span class="keywordtype">void</span> *)context {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&nbsp;    </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&nbsp;    BOOL isPrior = [[change objectForKey:NSKeyValueChangeNotificationIsPriorKey] boolValue];</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&nbsp;    <span class="keywordflow">if</span> (isPrior) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&nbsp;    </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&nbsp;    NSKeyValueChange changeKind = [[change objectForKey:NSKeyValueChangeKindKey] integerValue];</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&nbsp;    <span class="keywordflow">if</span> (changeKind != NSKeyValueChangeSetting) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&nbsp;    </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&nbsp;    <span class="keywordtype">id</span> newVal = [change objectForKey:NSKeyValueChangeNewKey];</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&nbsp;    <span class="keywordflow">if</span> (newVal == [NSNull <span class="keyword">null</span>]) newVal = nil;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&nbsp;    </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&nbsp;    <span class="keywordflow">if</span> (_notifyBlock) {</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&nbsp;        _notifyBlock(_keyboardView);</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&nbsp;    }</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&nbsp;}</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&nbsp; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&nbsp;<span class="keyword">@end</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&nbsp; </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&nbsp; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&nbsp; </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="interface_x_h_x_text_keyboard_manager.html">XHXTextKeyboardManager</a> {</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&nbsp;    NSHashTable *_observers;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&nbsp;    </div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">  106</a></span>&nbsp;    CGRect <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>;</div>
<div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#a4e25d7403955cf4a163763ac0ea282f5">  107</a></span>&nbsp;    BOOL <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a4e25d7403955cf4a163763ac0ea282f5">_fromVisible</a>;</div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#a65b6248ffb057531f1fe9247a86b5271">  108</a></span>&nbsp;    UIInterfaceOrientation <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a65b6248ffb057531f1fe9247a86b5271">_fromOrientation</a>;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&nbsp;    </div>
<div class="line"><a name="l00110"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#ab6da2fc00222a11ccead764ebdaed82f">  110</a></span>&nbsp;    CGRect <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ab6da2fc00222a11ccead764ebdaed82f">_notificationFromFrame</a>;</div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#afa77abf0d466d4f9aa360c7c3cddc19a">  111</a></span>&nbsp;    CGRect <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa77abf0d466d4f9aa360c7c3cddc19a">_notificationToFrame</a>;</div>
<div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#a2e05d81fbbdd32dbbfc787a371ef65f7">  112</a></span>&nbsp;    NSTimeInterval <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a2e05d81fbbdd32dbbfc787a371ef65f7">_notificationDuration</a>;</div>
<div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#a681534c5fb7511e7ade4254052500c3c">  113</a></span>&nbsp;    UIViewAnimationCurve <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a681534c5fb7511e7ade4254052500c3c">_notificationCurve</a>;</div>
<div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#ad0428514766fa4ba70e4e1929335f5dc">  114</a></span>&nbsp;    BOOL <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ad0428514766fa4ba70e4e1929335f5dc">_hasNotification</a>;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&nbsp;    </div>
<div class="line"><a name="l00116"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#a49525ed949ab3c5a97809f1a8dcbb563">  116</a></span>&nbsp;    CGRect <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a49525ed949ab3c5a97809f1a8dcbb563">_observedToFrame</a>;</div>
<div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#abccee6ddba6ef7510ebbe63ba3328176">  117</a></span>&nbsp;    BOOL <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#abccee6ddba6ef7510ebbe63ba3328176">_hasObservedChange</a>;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&nbsp;    </div>
<div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="_x_h_x_text_keyboard_manager_8m.html#afa1e10908bab765097e7bc6686b28c40">  119</a></span>&nbsp;    BOOL <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa1e10908bab765097e7bc6686b28c40">_lastIsNotification</a>;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&nbsp;}</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&nbsp; </div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&nbsp;- (instancetype)init {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&nbsp;    <span class="keyword">@throw</span> [NSException exceptionWithName:@&#34;XHXTextKeyboardManager init error&#34; reason:@&#34;Use &#39;defaultManager&#39; to get instance.&#34; userInfo:nil];</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&nbsp;    <span class="keywordflow">return</span> [<span class="keyword">super</span> init];</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&nbsp;}</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&nbsp; </div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&nbsp;- (instancetype)_init {</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&nbsp;    <span class="keyword">self</span> = [<span class="keyword">super</span> init];</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&nbsp;    _observers = [[NSHashTable alloc] initWithOptions:NSPointerFunctionsWeakMemory|NSPointerFunctionsObjectPointerPersonality capacity:0];</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&nbsp;    [[NSNotificationCenter defaultCenter] addObserver:self</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&nbsp;                                             selector:@selector(_keyboardFrameWillChangeNotification:)</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&nbsp;                                                 name:UIKeyboardWillChangeFrameNotification</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&nbsp;                                               object:nil];</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&nbsp;    <span class="comment">// for iPad (iOS 9)</span></div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&nbsp;    <span class="keywordflow">if</span> ([UIDevice currentDevice].systemVersion.floatValue &gt;= 9) {</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&nbsp;        [[NSNotificationCenter defaultCenter] addObserver:self</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&nbsp;                                                 selector:@selector(_keyboardFrameDidChangeNotification:)</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&nbsp;                                                     name:UIKeyboardDidChangeFrameNotification</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&nbsp;                                                   object:nil];</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&nbsp;    }</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&nbsp;    <span class="keywordflow">return</span> <span class="keyword">self</span>;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&nbsp;}</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&nbsp; </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&nbsp;- (void)_initFrameObserver {</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&nbsp;    UIView *keyboardView = <span class="keyword">self</span>.keyboardView;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&nbsp;    <span class="keywordflow">if</span> (!keyboardView) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&nbsp;    __weak typeof(<span class="keyword">self</span>) _self = self;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&nbsp;    <a class="code" href="interface___x_h_x_text_keyboard_view_frame_observer.html">_XHXTextKeyboardViewFrameObserver</a> *observer = [<a class="code" href="interface___x_h_x_text_keyboard_view_frame_observer.html">_XHXTextKeyboardViewFrameObserver</a> observerForView:keyboardView];</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&nbsp;    if (!observer) {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&nbsp;        observer = [<a class="code" href="interface___x_h_x_text_keyboard_view_frame_observer.html">_XHXTextKeyboardViewFrameObserver</a> new];</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&nbsp;        observer.<a class="code" href="interface___x_h_x_text_keyboard_view_frame_observer.html#a595de510eb2e5218fc4f387e8a7df2a0">notifyBlock</a> = ^(UIView *keyboard) {</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&nbsp;            [_self _keyboardFrameChanged:keyboard];</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&nbsp;        };</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&nbsp;        [observer addToKeyboardView:keyboardView];</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&nbsp;    }</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&nbsp;}</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&nbsp; </div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&nbsp;- (void)dealloc {</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&nbsp;    [[NSNotificationCenter defaultCenter] removeObserver:self];</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&nbsp;}</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&nbsp; </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&nbsp;+ (instancetype)defaultManager {</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&nbsp;    <span class="keyword">static</span> <a class="code" href="interface_x_h_x_text_keyboard_manager.html">XHXTextKeyboardManager</a> *mgr = nil;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&nbsp;    <span class="keyword">static</span> dispatch_once_t onceToken;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&nbsp;    dispatch_once(&amp;onceToken, ^{</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&nbsp;        <span class="keywordflow">if</span> (!<a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ad62ac520d11f2b28c8607820afd9065c">XHXTextIsAppExtension</a>()) {</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&nbsp;            mgr = [[<span class="keyword">self</span> alloc] _init];</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&nbsp;        }</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&nbsp;    });</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&nbsp;    <span class="keywordflow">return</span> mgr;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&nbsp;}</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&nbsp; </div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&nbsp;+ (void)load {</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&nbsp;    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&nbsp;        [<span class="keyword">self</span> defaultManager];</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&nbsp;    });</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&nbsp;}</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&nbsp; </div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&nbsp;- (void)addObserver:(<span class="keywordtype">id</span>&lt;<a class="code" href="protocol_x_h_x_text_keyboard_observer-p.html">XHXTextKeyboardObserver</a>&gt;)observer {</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&nbsp;    <span class="keywordflow">if</span> (!observer) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&nbsp;    [_observers addObject:observer];</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&nbsp;}</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&nbsp; </div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&nbsp;- (void)removeObserver:(<span class="keywordtype">id</span>&lt;<a class="code" href="protocol_x_h_x_text_keyboard_observer-p.html">XHXTextKeyboardObserver</a>&gt;)observer {</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&nbsp;    <span class="keywordflow">if</span> (!observer) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&nbsp;    [_observers removeObject:observer];</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&nbsp;}</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&nbsp; </div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&nbsp;- (UIWindow *)keyboardWindow {</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&nbsp;    UIApplication *app = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a7b31e4b1b1d2e323054fe61a1088a6d0">XHXTextSharedApplication</a>();</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&nbsp;    <span class="keywordflow">if</span> (!app) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&nbsp;    </div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&nbsp;    UIWindow *window = nil;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&nbsp;    <span class="keywordflow">for</span> (window in app.windows) {</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&nbsp;        <span class="keywordflow">if</span> ([<span class="keyword">self</span> _getKeyboardViewFromWindow:window]) <span class="keywordflow">return</span> window;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&nbsp;    }</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&nbsp;    window = app.keyWindow;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&nbsp;    <span class="keywordflow">if</span> ([<span class="keyword">self</span> _getKeyboardViewFromWindow:window]) <span class="keywordflow">return</span> window;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&nbsp;    </div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&nbsp;    NSMutableArray *kbWindows = nil;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&nbsp;    <span class="keywordflow">for</span> (window in app.windows) {</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&nbsp;        NSString *windowName = NSStringFromClass(window.class);</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&nbsp;        <span class="keywordflow">if</span> ([<span class="keyword">self</span> _systemVersion] &lt; 9) {</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&nbsp;            <span class="comment">// UITextEffectsWindow</span></div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&nbsp;            <span class="keywordflow">if</span> (windowName.length == 19 &amp;&amp;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&nbsp;                [windowName hasPrefix:<span class="stringliteral">@&#34;UI&#34;</span>] &amp;&amp;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&nbsp;                [windowName hasSuffix:<span class="stringliteral">@&#34;TextEffectsWindow&#34;</span>]) {</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&nbsp;                <span class="keywordflow">if</span> (!kbWindows) kbWindows = [NSMutableArray new];</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&nbsp;                [kbWindows addObject:window];</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&nbsp;            }</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&nbsp;        } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&nbsp;            <span class="comment">// UIRemoteKeyboardWindow</span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&nbsp;            <span class="keywordflow">if</span> (windowName.length == 22 &amp;&amp;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&nbsp;                [windowName hasPrefix:<span class="stringliteral">@&#34;UI&#34;</span>] &amp;&amp;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&nbsp;                [windowName hasSuffix:<span class="stringliteral">@&#34;RemoteKeyboardWindow&#34;</span>]) {</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&nbsp;                <span class="keywordflow">if</span> (!kbWindows) kbWindows = [NSMutableArray new];</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&nbsp;                [kbWindows addObject:window];</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&nbsp;            }</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&nbsp;        }</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&nbsp;    }</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&nbsp;    </div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&nbsp;    <span class="keywordflow">if</span> (kbWindows.count == 1) {</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&nbsp;        <span class="keywordflow">return</span> kbWindows.firstObject;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&nbsp;    }</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&nbsp;    <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&nbsp;}</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&nbsp; </div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&nbsp;- (UIView *)keyboardView {</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&nbsp;    UIApplication *app = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a7b31e4b1b1d2e323054fe61a1088a6d0">XHXTextSharedApplication</a>();</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&nbsp;    <span class="keywordflow">if</span> (!app) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&nbsp;    </div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&nbsp;    UIWindow *window = nil;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&nbsp;    UIView *view = nil;</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&nbsp;    <span class="keywordflow">for</span> (window in app.windows) {</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&nbsp;        view = [<span class="keyword">self</span> _getKeyboardViewFromWindow:window];</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&nbsp;        <span class="keywordflow">if</span> (view) <span class="keywordflow">return</span> view;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&nbsp;    }</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&nbsp;    window = app.keyWindow;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&nbsp;    view = [<span class="keyword">self</span> _getKeyboardViewFromWindow:window];</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&nbsp;    <span class="keywordflow">if</span> (view) <span class="keywordflow">return</span> view;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&nbsp;    <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&nbsp;}</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&nbsp; </div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&nbsp;- (BOOL)isKeyboardVisible {</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&nbsp;    UIWindow *window = <span class="keyword">self</span>.keyboardWindow;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&nbsp;    <span class="keywordflow">if</span> (!window) <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&nbsp;    UIView *view = <span class="keyword">self</span>.keyboardView;</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&nbsp;    <span class="keywordflow">if</span> (!view) <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&nbsp;    CGRect rect = CGRectIntersection(window.bounds, view.frame);</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&nbsp;    <span class="keywordflow">if</span> (CGRectIsNull(rect)) <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&nbsp;    <span class="keywordflow">if</span> (CGRectIsInfinite(rect)) <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&nbsp;    <span class="keywordflow">return</span> rect.size.width &gt; 0 &amp;&amp; rect.size.height &gt; 0;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&nbsp;}</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&nbsp; </div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&nbsp;- (CGRect)keyboardFrame {</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&nbsp;    UIView *keyboard = [<span class="keyword">self</span> keyboardView];</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&nbsp;    <span class="keywordflow">if</span> (!keyboard) <span class="keywordflow">return</span> CGRectNull;</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&nbsp;    </div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&nbsp;    CGRect frame = CGRectNull;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&nbsp;    UIWindow *window = keyboard.window;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&nbsp;    <span class="keywordflow">if</span> (window) {</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&nbsp;        frame = [window convertRect:keyboard.frame toWindow:nil];</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&nbsp;        frame = keyboard.frame;</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&nbsp;    }</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&nbsp;    <span class="keywordflow">return</span> frame;</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&nbsp;}</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&nbsp; </div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&nbsp;<span class="preprocessor">#pragma mark - private</span></div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&nbsp; </div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&nbsp;- (double)_systemVersion {</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&nbsp;    <span class="keyword">static</span> <span class="keywordtype">double</span> v;</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&nbsp;    <span class="keyword">static</span> dispatch_once_t onceToken;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&nbsp;    dispatch_once(&amp;onceToken, ^{</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&nbsp;        v = [UIDevice currentDevice].systemVersion.doubleValue;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&nbsp;    });</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&nbsp;    <span class="keywordflow">return</span> v;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&nbsp;}</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&nbsp; </div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&nbsp;- (UIView *)_getKeyboardViewFromWindow:(UIWindow *)window {</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&nbsp;    <span class="comment">/*</span></div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&nbsp;<span class="comment">     iOS 6/7:</span></div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&nbsp;<span class="comment">     UITextEffectsWindow</span></div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&nbsp;<span class="comment">     UIPeripheralHostView &lt;&lt; keyboard</span></div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&nbsp;<span class="comment">     </span></div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&nbsp;<span class="comment">     iOS 8:</span></div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&nbsp;<span class="comment">     UITextEffectsWindow</span></div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&nbsp;<span class="comment">     UIInputSetContainerView</span></div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&nbsp;<span class="comment">     UIInputSetHostView &lt;&lt; keyboard</span></div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&nbsp;<span class="comment">     </span></div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&nbsp;<span class="comment">     iOS 9:</span></div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&nbsp;<span class="comment">     UIRemoteKeyboardWindow</span></div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&nbsp;<span class="comment">     UIInputSetContainerView</span></div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&nbsp;<span class="comment">     UIInputSetHostView &lt;&lt; keyboard</span></div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&nbsp;<span class="comment">     */</span></div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&nbsp;    <span class="keywordflow">if</span> (!window) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&nbsp;    </div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&nbsp;    <span class="comment">// Get the window</span></div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&nbsp;    NSString *windowName = NSStringFromClass(window.class);</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&nbsp;    <span class="keywordflow">if</span> ([<span class="keyword">self</span> _systemVersion] &lt; 9) {</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&nbsp;        <span class="comment">// UITextEffectsWindow</span></div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&nbsp;        <span class="keywordflow">if</span> (windowName.length != 19) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&nbsp;        <span class="keywordflow">if</span> (![windowName hasPrefix:<span class="stringliteral">@&#34;UI&#34;</span>]) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&nbsp;        <span class="keywordflow">if</span> (![windowName hasSuffix:<span class="stringliteral">@&#34;TextEffectsWindow&#34;</span>]) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&nbsp;        <span class="comment">// UIRemoteKeyboardWindow</span></div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&nbsp;        <span class="keywordflow">if</span> (windowName.length != 22) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&nbsp;        <span class="keywordflow">if</span> (![windowName hasPrefix:<span class="stringliteral">@&#34;UI&#34;</span>]) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&nbsp;        <span class="keywordflow">if</span> (![windowName hasSuffix:<span class="stringliteral">@&#34;RemoteKeyboardWindow&#34;</span>]) <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&nbsp;    }</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&nbsp;    </div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&nbsp;    <span class="comment">// Get the view</span></div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&nbsp;    <span class="keywordflow">if</span> ([<span class="keyword">self</span> _systemVersion] &lt; 8) {</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&nbsp;        <span class="comment">// UIPeripheralHostView</span></div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&nbsp;        <span class="keywordflow">for</span> (UIView *view in window.subviews) {</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&nbsp;            NSString *viewName = NSStringFromClass(view.class);</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&nbsp;            <span class="keywordflow">if</span> (viewName.length != 20) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&nbsp;            <span class="keywordflow">if</span> (![viewName hasPrefix:<span class="stringliteral">@&#34;UI&#34;</span>]) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&nbsp;            <span class="keywordflow">if</span> (![viewName hasSuffix:<span class="stringliteral">@&#34;PeripheralHostView&#34;</span>]) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&nbsp;            <span class="keywordflow">return</span> view;</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&nbsp;        }</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&nbsp;        <span class="comment">// UIInputSetContainerView</span></div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&nbsp;        <span class="keywordflow">for</span> (UIView *view in window.subviews) {</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&nbsp;            NSString *viewName = NSStringFromClass(view.class);</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&nbsp;            <span class="keywordflow">if</span> (viewName.length != 23) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&nbsp;            <span class="keywordflow">if</span> (![viewName hasPrefix:<span class="stringliteral">@&#34;UI&#34;</span>]) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&nbsp;            <span class="keywordflow">if</span> (![viewName hasSuffix:<span class="stringliteral">@&#34;InputSetContainerView&#34;</span>]) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&nbsp;            <span class="comment">// UIInputSetHostView</span></div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&nbsp;            <span class="keywordflow">for</span> (UIView *subView in view.subviews) {</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&nbsp;                NSString *subViewName = NSStringFromClass(subView.class);</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&nbsp;                <span class="keywordflow">if</span> (subViewName.length != 18) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&nbsp;                <span class="keywordflow">if</span> (![subViewName hasPrefix:<span class="stringliteral">@&#34;UI&#34;</span>]) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&nbsp;                <span class="keywordflow">if</span> (![subViewName hasSuffix:<span class="stringliteral">@&#34;InputSetHostView&#34;</span>]) <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&nbsp;                <span class="keywordflow">return</span> subView;</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&nbsp;            }</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&nbsp;        }</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&nbsp;    }</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&nbsp;    </div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&nbsp;    <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&nbsp;}</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&nbsp; </div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&nbsp;- (void)_keyboardFrameWillChangeNotification:(NSNotification *)notif {</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&nbsp;    <span class="keywordflow">if</span> (![notif.name isEqualToString:UIKeyboardWillChangeFrameNotification]) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&nbsp;    NSDictionary *info = notif.userInfo;</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&nbsp;    <span class="keywordflow">if</span> (!info) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&nbsp;    </div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&nbsp;    [<span class="keyword">self</span> _initFrameObserver];</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&nbsp;    </div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&nbsp;    NSValue *beforeValue = info[UIKeyboardFrameBeginUserInfoKey];</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&nbsp;    NSValue *afterValue = info[UIKeyboardFrameEndUserInfoKey];</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&nbsp;    NSNumber *curveNumber = info[UIKeyboardAnimationCurveUserInfoKey];</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&nbsp;    NSNumber *durationNumber = info[UIKeyboardAnimationDurationUserInfoKey];</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&nbsp;    </div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&nbsp;    CGRect before = beforeValue.CGRectValue;</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&nbsp;    CGRect after = afterValue.CGRectValue;</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&nbsp;    UIViewAnimationCurve curve = curveNumber.integerValue;</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&nbsp;    NSTimeInterval duration = durationNumber.doubleValue;</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&nbsp;    </div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&nbsp;    <span class="comment">// ignore zero end frame</span></div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&nbsp;    <span class="keywordflow">if</span> (after.size.width &lt;= 0 &amp;&amp; after.size.height &lt;= 0) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&nbsp;    </div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ab6da2fc00222a11ccead764ebdaed82f">_notificationFromFrame</a> = before;</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa77abf0d466d4f9aa360c7c3cddc19a">_notificationToFrame</a> = after;</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a681534c5fb7511e7ade4254052500c3c">_notificationCurve</a> = curve;</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a2e05d81fbbdd32dbbfc787a371ef65f7">_notificationDuration</a> = duration;</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ad0428514766fa4ba70e4e1929335f5dc">_hasNotification</a> = YES;</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa1e10908bab765097e7bc6686b28c40">_lastIsNotification</a> = YES;</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&nbsp;    </div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&nbsp;    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(_notifyAllObservers) object:nil];</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&nbsp;    <span class="keywordflow">if</span> (duration == 0) {</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&nbsp;        [<span class="keyword">self</span> performSelector:@selector(_notifyAllObservers) withObject:nil afterDelay:0 inModes:@[NSRunLoopCommonModes]];</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&nbsp;        [<span class="keyword">self</span> _notifyAllObservers];</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&nbsp;    }</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&nbsp;}</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&nbsp; </div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&nbsp;- (void)_keyboardFrameDidChangeNotification:(NSNotification *)notif {</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&nbsp;    <span class="keywordflow">if</span> (![notif.name isEqualToString:UIKeyboardDidChangeFrameNotification]) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&nbsp;    NSDictionary *info = notif.userInfo;</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&nbsp;    <span class="keywordflow">if</span> (!info) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&nbsp;    </div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&nbsp;    [<span class="keyword">self</span> _initFrameObserver];</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&nbsp;    </div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&nbsp;    NSValue *afterValue = info[UIKeyboardFrameEndUserInfoKey];</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&nbsp;    CGRect after = afterValue.CGRectValue;</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&nbsp;    </div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&nbsp;    <span class="comment">// ignore zero end frame</span></div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&nbsp;    <span class="keywordflow">if</span> (after.size.width &lt;= 0 &amp;&amp; after.size.height &lt;= 0) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&nbsp;    </div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa77abf0d466d4f9aa360c7c3cddc19a">_notificationToFrame</a> = after;</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a681534c5fb7511e7ade4254052500c3c">_notificationCurve</a> = UIViewAnimationCurveEaseInOut;</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a2e05d81fbbdd32dbbfc787a371ef65f7">_notificationDuration</a> = 0;</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ad0428514766fa4ba70e4e1929335f5dc">_hasNotification</a> = YES;</div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa1e10908bab765097e7bc6686b28c40">_lastIsNotification</a> = YES;</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&nbsp;    </div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&nbsp;    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(_notifyAllObservers) object:nil];</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&nbsp;    [<span class="keyword">self</span> performSelector:@selector(_notifyAllObservers) withObject:nil afterDelay:0 inModes:@[NSRunLoopCommonModes]];</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&nbsp;}</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&nbsp; </div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&nbsp;- (void)_keyboardFrameChanged:(UIView *)keyboard {</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&nbsp;    <span class="keywordflow">if</span> (keyboard != <span class="keyword">self</span>.keyboardView) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&nbsp;    </div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&nbsp;    UIWindow *window = keyboard.window;</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&nbsp;    <span class="keywordflow">if</span> (window) {</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&nbsp;        <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a49525ed949ab3c5a97809f1a8dcbb563">_observedToFrame</a> = [window convertRect:keyboard.frame toWindow:nil];</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&nbsp;        <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a49525ed949ab3c5a97809f1a8dcbb563">_observedToFrame</a> = keyboard.frame;</div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&nbsp;    }</div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#abccee6ddba6ef7510ebbe63ba3328176">_hasObservedChange</a> = YES;</div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa1e10908bab765097e7bc6686b28c40">_lastIsNotification</a> = NO;</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&nbsp;    </div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&nbsp;    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(_notifyAllObservers) object:nil];</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&nbsp;    [<span class="keyword">self</span> performSelector:@selector(_notifyAllObservers) withObject:nil afterDelay:0 inModes:@[NSRunLoopCommonModes]];</div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&nbsp;}</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&nbsp; </div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&nbsp;- (void)_notifyAllObservers {</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&nbsp;    UIApplication *app = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a7b31e4b1b1d2e323054fe61a1088a6d0">XHXTextSharedApplication</a>();</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&nbsp;    <span class="keywordflow">if</span> (!app) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&nbsp;    </div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&nbsp;    UIView *keyboard = <span class="keyword">self</span>.keyboardView;</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&nbsp;    UIWindow *window = keyboard.window;</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&nbsp;    <span class="keywordflow">if</span> (!window) {</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&nbsp;        window = app.keyWindow;</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&nbsp;    }</div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&nbsp;    <span class="keywordflow">if</span> (!window) {</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&nbsp;        window = app.windows.firstObject;</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&nbsp;    }</div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&nbsp;    </div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&nbsp;    <a class="code" href="struct_x_h_x_text_keyboard_transition.html">XHXTextKeyboardTransition</a> trans = {0};</div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&nbsp;    </div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&nbsp;    <span class="comment">// from</span></div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&nbsp;    <span class="keywordflow">if</span> (<a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>.size.width == 0 &amp;&amp; <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>.size.height == 0) { <span class="comment">// first notify</span></div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&nbsp;        <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>.size.width = window.bounds.size.width;</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&nbsp;        <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>.size.height = trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>.size.height;</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&nbsp;        <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>.origin.x = trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>.origin.x;</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&nbsp;        <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>.origin.y = window.bounds.size.height;</div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&nbsp;    }</div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&nbsp;    trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#aad15905ae428fe9bfdfad2010087b680">fromFrame</a> = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>;</div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&nbsp;    trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a0b00535442714dc6ccf8e68a34fb91f3">fromVisible</a> = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a4e25d7403955cf4a163763ac0ea282f5">_fromVisible</a>;</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&nbsp;    </div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&nbsp;    <span class="comment">// to</span></div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&nbsp;    <span class="keywordflow">if</span> (<a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa1e10908bab765097e7bc6686b28c40">_lastIsNotification</a> || (<a class="code" href="_x_h_x_text_keyboard_manager_8m.html#abccee6ddba6ef7510ebbe63ba3328176">_hasObservedChange</a> &amp;&amp; CGRectEqualToRect(<a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a49525ed949ab3c5a97809f1a8dcbb563">_observedToFrame</a>, <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa77abf0d466d4f9aa360c7c3cddc19a">_notificationToFrame</a>))) {</div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&nbsp;        trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a> = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#afa77abf0d466d4f9aa360c7c3cddc19a">_notificationToFrame</a>;</div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&nbsp;        trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a6d215ca6c6f122a9a0af0e7b48040693">animationDuration</a> = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a2e05d81fbbdd32dbbfc787a371ef65f7">_notificationDuration</a>;</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&nbsp;        trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#afacd2636b7e1409a917dad69d10a06e1">animationCurve</a> = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a681534c5fb7511e7ade4254052500c3c">_notificationCurve</a>;</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&nbsp;        trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a1f968b27988feec878f28406635023fe">animationOption</a> = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a681534c5fb7511e7ade4254052500c3c">_notificationCurve</a> &lt;&lt; 16;</div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&nbsp;        </div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&nbsp;        <span class="comment">// Fix iPad(iOS7) keyboard frame error after rorate device when the keyboard is not docked to bottom.</span></div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&nbsp;        <span class="keywordflow">if</span> (((<span class="keywordtype">int</span>)[<span class="keyword">self</span> _systemVersion]) == 7) {</div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&nbsp;            UIInterfaceOrientation ori = app.statusBarOrientation;</div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&nbsp;            <span class="keywordflow">if</span> (<a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a65b6248ffb057531f1fe9247a86b5271">_fromOrientation</a> != UIInterfaceOrientationUnknown &amp;&amp; <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a65b6248ffb057531f1fe9247a86b5271">_fromOrientation</a> != ori) {</div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&nbsp;                <span class="keywordflow">switch</span> (ori) {</div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&nbsp;                    <span class="keywordflow">case</span> UIInterfaceOrientationPortrait: {</div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&nbsp;                        <span class="keywordflow">if</span> (CGRectGetMaxY(trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>) != window.frame.size.height) {</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&nbsp;                            trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>.origin.y -= trans.toFrame.size.height;</div>
<div class="line"><a name="l00457"></a><span class="lineno">  457</span>&nbsp;                        }</div>
<div class="line"><a name="l00458"></a><span class="lineno">  458</span>&nbsp;                    } <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00459"></a><span class="lineno">  459</span>&nbsp;                    <span class="keywordflow">case</span> UIInterfaceOrientationPortraitUpsideDown: {</div>
<div class="line"><a name="l00460"></a><span class="lineno">  460</span>&nbsp;                        <span class="keywordflow">if</span> (CGRectGetMinY(trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>) != 0) {</div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&nbsp;                            trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>.origin.y += trans.toFrame.size.height;</div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&nbsp;                        }</div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&nbsp;                    } <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&nbsp;                    <span class="keywordflow">case</span> UIInterfaceOrientationLandscapeLeft: {</div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&nbsp;                        <span class="keywordflow">if</span> (CGRectGetMaxX(trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>) != window.frame.size.width) {</div>
<div class="line"><a name="l00466"></a><span class="lineno">  466</span>&nbsp;                            trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>.origin.x -= trans.toFrame.size.width;</div>
<div class="line"><a name="l00467"></a><span class="lineno">  467</span>&nbsp;                        }</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&nbsp;                    } <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00469"></a><span class="lineno">  469</span>&nbsp;                    <span class="keywordflow">case</span> UIInterfaceOrientationLandscapeRight: {</div>
<div class="line"><a name="l00470"></a><span class="lineno">  470</span>&nbsp;                        <span class="keywordflow">if</span> (CGRectGetMinX(trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>) != 0) {</div>
<div class="line"><a name="l00471"></a><span class="lineno">  471</span>&nbsp;                            trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>.origin.x += trans.toFrame.size.width;</div>
<div class="line"><a name="l00472"></a><span class="lineno">  472</span>&nbsp;                        }</div>
<div class="line"><a name="l00473"></a><span class="lineno">  473</span>&nbsp;                    } <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00474"></a><span class="lineno">  474</span>&nbsp;                    <span class="keywordflow">default</span>: <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00475"></a><span class="lineno">  475</span>&nbsp;                }</div>
<div class="line"><a name="l00476"></a><span class="lineno">  476</span>&nbsp;            }</div>
<div class="line"><a name="l00477"></a><span class="lineno">  477</span>&nbsp;        }</div>
<div class="line"><a name="l00478"></a><span class="lineno">  478</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00479"></a><span class="lineno">  479</span>&nbsp;        trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a> = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a49525ed949ab3c5a97809f1a8dcbb563">_observedToFrame</a>;</div>
<div class="line"><a name="l00480"></a><span class="lineno">  480</span>&nbsp;    }</div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&nbsp;    </div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&nbsp;    <span class="keywordflow">if</span> (window &amp;&amp; trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>.size.width &gt; 0 &amp;&amp; trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>.size.height &gt; 0) {</div>
<div class="line"><a name="l00483"></a><span class="lineno">  483</span>&nbsp;        CGRect rect = CGRectIntersection(window.bounds, trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>);</div>
<div class="line"><a name="l00484"></a><span class="lineno">  484</span>&nbsp;        <span class="keywordflow">if</span> (!CGRectIsNull(rect) &amp;&amp; !CGRectIsEmpty(rect)) {</div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&nbsp;            trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#af664f9a3d1c9aa90b635f6c94c383679">toVisible</a> = YES;</div>
<div class="line"><a name="l00486"></a><span class="lineno">  486</span>&nbsp;        }</div>
<div class="line"><a name="l00487"></a><span class="lineno">  487</span>&nbsp;    }</div>
<div class="line"><a name="l00488"></a><span class="lineno">  488</span>&nbsp;    </div>
<div class="line"><a name="l00489"></a><span class="lineno">  489</span>&nbsp;    <span class="keywordflow">if</span> (!CGRectEqualToRect(trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>, <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a>)) {</div>
<div class="line"><a name="l00490"></a><span class="lineno">  490</span>&nbsp;        <span class="keywordflow">for</span> (id&lt;XHXTextKeyboardObserver&gt; observer in _observers.copy) {</div>
<div class="line"><a name="l00491"></a><span class="lineno">  491</span>&nbsp;            <span class="keywordflow">if</span> ([observer respondsToSelector:<span class="keyword">@selector</span>(keyboardChangedWithTransition:)]) {</div>
<div class="line"><a name="l00492"></a><span class="lineno">  492</span>&nbsp;                [observer <a class="code" href="protocol_x_h_x_text_keyboard_observer-p.html#a86d508f78d636624b318273a94a6104d">keyboardChangedWithTransition</a>:trans];</div>
<div class="line"><a name="l00493"></a><span class="lineno">  493</span>&nbsp;            }</div>
<div class="line"><a name="l00494"></a><span class="lineno">  494</span>&nbsp;        }</div>
<div class="line"><a name="l00495"></a><span class="lineno">  495</span>&nbsp;    }</div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&nbsp;    </div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#ad0428514766fa4ba70e4e1929335f5dc">_hasNotification</a> = NO;</div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#abccee6ddba6ef7510ebbe63ba3328176">_hasObservedChange</a> = NO;</div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a> = trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">toFrame</a>;</div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a4e25d7403955cf4a163763ac0ea282f5">_fromVisible</a> = trans.<a class="code" href="struct_x_h_x_text_keyboard_transition.html#af664f9a3d1c9aa90b635f6c94c383679">toVisible</a>;</div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&nbsp;    <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a65b6248ffb057531f1fe9247a86b5271">_fromOrientation</a> = app.statusBarOrientation;</div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&nbsp;}</div>
<div class="line"><a name="l00503"></a><span class="lineno">  503</span>&nbsp; </div>
<div class="line"><a name="l00504"></a><span class="lineno">  504</span>&nbsp;- (CGRect)convertRect:(CGRect)rect toView:(UIView *)view {</div>
<div class="line"><a name="l00505"></a><span class="lineno">  505</span>&nbsp;    UIApplication *app = <a class="code" href="_x_h_x_text_keyboard_manager_8m.html#a7b31e4b1b1d2e323054fe61a1088a6d0">XHXTextSharedApplication</a>();</div>
<div class="line"><a name="l00506"></a><span class="lineno">  506</span>&nbsp;    <span class="keywordflow">if</span> (!app) <span class="keywordflow">return</span> CGRectZero;</div>
<div class="line"><a name="l00507"></a><span class="lineno">  507</span>&nbsp;    </div>
<div class="line"><a name="l00508"></a><span class="lineno">  508</span>&nbsp;    <span class="keywordflow">if</span> (CGRectIsNull(rect)) <span class="keywordflow">return</span> rect;</div>
<div class="line"><a name="l00509"></a><span class="lineno">  509</span>&nbsp;    <span class="keywordflow">if</span> (CGRectIsInfinite(rect)) <span class="keywordflow">return</span> rect;</div>
<div class="line"><a name="l00510"></a><span class="lineno">  510</span>&nbsp;    </div>
<div class="line"><a name="l00511"></a><span class="lineno">  511</span>&nbsp;    UIWindow *mainWindow = app.keyWindow;</div>
<div class="line"><a name="l00512"></a><span class="lineno">  512</span>&nbsp;    <span class="keywordflow">if</span> (!mainWindow) mainWindow = app.windows.firstObject;</div>
<div class="line"><a name="l00513"></a><span class="lineno">  513</span>&nbsp;    <span class="keywordflow">if</span> (!mainWindow) { <span class="comment">// no window ?!</span></div>
<div class="line"><a name="l00514"></a><span class="lineno">  514</span>&nbsp;        <span class="keywordflow">if</span> (view) {</div>
<div class="line"><a name="l00515"></a><span class="lineno">  515</span>&nbsp;            [view convertRect:rect fromView:nil];</div>
<div class="line"><a name="l00516"></a><span class="lineno">  516</span>&nbsp;        } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00517"></a><span class="lineno">  517</span>&nbsp;            <span class="keywordflow">return</span> rect;</div>
<div class="line"><a name="l00518"></a><span class="lineno">  518</span>&nbsp;        }</div>
<div class="line"><a name="l00519"></a><span class="lineno">  519</span>&nbsp;    }</div>
<div class="line"><a name="l00520"></a><span class="lineno">  520</span>&nbsp;    </div>
<div class="line"><a name="l00521"></a><span class="lineno">  521</span>&nbsp;    rect = [mainWindow convertRect:rect fromWindow:nil];</div>
<div class="line"><a name="l00522"></a><span class="lineno">  522</span>&nbsp;    <span class="keywordflow">if</span> (!view) <span class="keywordflow">return</span> [mainWindow convertRect:rect toWindow:nil];</div>
<div class="line"><a name="l00523"></a><span class="lineno">  523</span>&nbsp;    <span class="keywordflow">if</span> (view == mainWindow) <span class="keywordflow">return</span> rect;</div>
<div class="line"><a name="l00524"></a><span class="lineno">  524</span>&nbsp;    </div>
<div class="line"><a name="l00525"></a><span class="lineno">  525</span>&nbsp;    UIWindow *toWindow = [view isKindOfClass:[UIWindow class]] ? (id)view : view.window;</div>
<div class="line"><a name="l00526"></a><span class="lineno">  526</span>&nbsp;    if (!mainWindow || !toWindow) <span class="keywordflow">return</span> [mainWindow convertRect:rect toView:view];</div>
<div class="line"><a name="l00527"></a><span class="lineno">  527</span>&nbsp;    <span class="keywordflow">if</span> (mainWindow == toWindow) <span class="keywordflow">return</span> [mainWindow convertRect:rect toView:view];</div>
<div class="line"><a name="l00528"></a><span class="lineno">  528</span>&nbsp;    </div>
<div class="line"><a name="l00529"></a><span class="lineno">  529</span>&nbsp;    <span class="comment">// in different window</span></div>
<div class="line"><a name="l00530"></a><span class="lineno">  530</span>&nbsp;    rect = [mainWindow convertRect:rect toView:mainWindow];</div>
<div class="line"><a name="l00531"></a><span class="lineno">  531</span>&nbsp;    rect = [toWindow convertRect:rect fromWindow:mainWindow];</div>
<div class="line"><a name="l00532"></a><span class="lineno">  532</span>&nbsp;    rect = [view convertRect:rect fromView:toWindow];</div>
<div class="line"><a name="l00533"></a><span class="lineno">  533</span>&nbsp;    <span class="keywordflow">return</span> rect;</div>
<div class="line"><a name="l00534"></a><span class="lineno">  534</span>&nbsp;}</div>
<div class="line"><a name="l00535"></a><span class="lineno">  535</span>&nbsp; </div>
<div class="line"><a name="l00536"></a><span class="lineno">  536</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astruct_x_h_x_text_keyboard_transition_html_a6d215ca6c6f122a9a0af0e7b48040693"><div class="ttname"><a href="struct_x_h_x_text_keyboard_transition.html#a6d215ca6c6f122a9a0af0e7b48040693">XHXTextKeyboardTransition::animationDuration</a></div><div class="ttdeci">NSTimeInterval animationDuration</div><div class="ttdoc">Keyboard transition animation duration.</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00023">XHXTextKeyboardManager.h:23</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_ab6da2fc00222a11ccead764ebdaed82f"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#ab6da2fc00222a11ccead764ebdaed82f">_notificationFromFrame</a></div><div class="ttdeci">CGRect _notificationFromFrame</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00110">XHXTextKeyboardManager.m:110</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_a681534c5fb7511e7ade4254052500c3c"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#a681534c5fb7511e7ade4254052500c3c">_notificationCurve</a></div><div class="ttdeci">UIViewAnimationCurve _notificationCurve</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00113">XHXTextKeyboardManager.m:113</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_a65b6248ffb057531f1fe9247a86b5271"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#a65b6248ffb057531f1fe9247a86b5271">_fromOrientation</a></div><div class="ttdeci">UIInterfaceOrientation _fromOrientation</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00108">XHXTextKeyboardManager.m:108</a></div></div>
<div class="ttc" id="aprotocol_x_h_x_text_keyboard_observer-p_html"><div class="ttname"><a href="protocol_x_h_x_text_keyboard_observer-p.html">XHXTextKeyboardObserver-p</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00033">XHXTextKeyboardManager.h:33</a></div></div>
<div class="ttc" id="astruct_x_h_x_text_keyboard_transition_html_aad15905ae428fe9bfdfad2010087b680"><div class="ttname"><a href="struct_x_h_x_text_keyboard_transition.html#aad15905ae428fe9bfdfad2010087b680">XHXTextKeyboardTransition::fromFrame</a></div><div class="ttdeci">CGRect fromFrame</div><div class="ttdoc">Keyboard frame before transition.</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00021">XHXTextKeyboardManager.h:21</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_abccee6ddba6ef7510ebbe63ba3328176"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#abccee6ddba6ef7510ebbe63ba3328176">_hasObservedChange</a></div><div class="ttdeci">BOOL _hasObservedChange</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00117">XHXTextKeyboardManager.m:117</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_ad62ac520d11f2b28c8607820afd9065c"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#ad62ac520d11f2b28c8607820afd9065c">XHXTextIsAppExtension</a></div><div class="ttdeci">BOOL XHXTextIsAppExtension()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00013">XHXTextKeyboardManager.m:13</a></div></div>
<div class="ttc" id="astruct_x_h_x_text_keyboard_transition_html_afacd2636b7e1409a917dad69d10a06e1"><div class="ttname"><a href="struct_x_h_x_text_keyboard_transition.html#afacd2636b7e1409a917dad69d10a06e1">XHXTextKeyboardTransition::animationCurve</a></div><div class="ttdeci">UIViewAnimationCurve animationCurve</div><div class="ttdoc">Keyboard transition animation curve.</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00024">XHXTextKeyboardManager.h:24</a></div></div>
<div class="ttc" id="astruct_x_h_x_text_keyboard_transition_html_af664f9a3d1c9aa90b635f6c94c383679"><div class="ttname"><a href="struct_x_h_x_text_keyboard_transition.html#af664f9a3d1c9aa90b635f6c94c383679">XHXTextKeyboardTransition::toVisible</a></div><div class="ttdeci">BOOL toVisible</div><div class="ttdoc">Keyboard visible after transition.</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00020">XHXTextKeyboardManager.h:20</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_a4e25d7403955cf4a163763ac0ea282f5"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#a4e25d7403955cf4a163763ac0ea282f5">_fromVisible</a></div><div class="ttdeci">BOOL _fromVisible</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00107">XHXTextKeyboardManager.m:107</a></div></div>
<div class="ttc" id="astruct_x_h_x_text_keyboard_transition_html_a97527530fdc984218af25924c085e936"><div class="ttname"><a href="struct_x_h_x_text_keyboard_transition.html#a97527530fdc984218af25924c085e936">XHXTextKeyboardTransition::toFrame</a></div><div class="ttdeci">CGRect toFrame</div><div class="ttdoc">Keyboard frame after transition.</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00022">XHXTextKeyboardManager.h:22</a></div></div>
<div class="ttc" id="ainterface_x_h_x_text_keyboard_manager_html"><div class="ttname"><a href="interface_x_h_x_text_keyboard_manager.html">XHXTextKeyboardManager</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00046">XHXTextKeyboardManager.h:47</a></div></div>
<div class="ttc" id="ainterface___x_h_x_text_keyboard_view_frame_observer_html_a595de510eb2e5218fc4f387e8a7df2a0"><div class="ttname"><a href="interface___x_h_x_text_keyboard_view_frame_observer.html#a595de510eb2e5218fc4f387e8a7df2a0">_XHXTextKeyboardViewFrameObserver::notifyBlock</a></div><div class="ttdeci">void(^ notifyBlock)(UIView *keyboard)</div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_a7b31e4b1b1d2e323054fe61a1088a6d0"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#a7b31e4b1b1d2e323054fe61a1088a6d0">XHXTextSharedApplication</a></div><div class="ttdeci">UIApplication * XHXTextSharedApplication()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00024">XHXTextKeyboardManager.m:24</a></div></div>
<div class="ttc" id="astruct_x_h_x_text_keyboard_transition_html"><div class="ttname"><a href="struct_x_h_x_text_keyboard_transition.html">XHXTextKeyboardTransition</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00018">XHXTextKeyboardManager.h:18</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_a5c42c49216d0199c2ec23de072e7f86e"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#a5c42c49216d0199c2ec23de072e7f86e">_fromFrame</a></div><div class="ttdeci">CGRect _fromFrame</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00106">XHXTextKeyboardManager.m:103</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_afa77abf0d466d4f9aa360c7c3cddc19a"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#afa77abf0d466d4f9aa360c7c3cddc19a">_notificationToFrame</a></div><div class="ttdeci">CGRect _notificationToFrame</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00111">XHXTextKeyboardManager.m:111</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_a49525ed949ab3c5a97809f1a8dcbb563"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#a49525ed949ab3c5a97809f1a8dcbb563">_observedToFrame</a></div><div class="ttdeci">CGRect _observedToFrame</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00116">XHXTextKeyboardManager.m:116</a></div></div>
<div class="ttc" id="astruct_x_h_x_text_keyboard_transition_html_a1f968b27988feec878f28406635023fe"><div class="ttname"><a href="struct_x_h_x_text_keyboard_transition.html#a1f968b27988feec878f28406635023fe">XHXTextKeyboardTransition::animationOption</a></div><div class="ttdeci">UIViewAnimationOptions animationOption</div><div class="ttdoc">Keybaord transition animation option.</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00025">XHXTextKeyboardManager.h:25</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8h_html"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8h.html">XHXTextKeyboardManager.h</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_a2e05d81fbbdd32dbbfc787a371ef65f7"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#a2e05d81fbbdd32dbbfc787a371ef65f7">_notificationDuration</a></div><div class="ttdeci">NSTimeInterval _notificationDuration</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00112">XHXTextKeyboardManager.m:112</a></div></div>
<div class="ttc" id="astruct_x_h_x_text_keyboard_transition_html_a0b00535442714dc6ccf8e68a34fb91f3"><div class="ttname"><a href="struct_x_h_x_text_keyboard_transition.html#a0b00535442714dc6ccf8e68a34fb91f3">XHXTextKeyboardTransition::fromVisible</a></div><div class="ttdeci">BOOL fromVisible</div><div class="ttdoc">Keyboard visible before transition.</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8h_source.html#l00019">XHXTextKeyboardManager.h:19</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_ad0428514766fa4ba70e4e1929335f5dc"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#ad0428514766fa4ba70e4e1929335f5dc">_hasNotification</a></div><div class="ttdeci">BOOL _hasNotification</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00114">XHXTextKeyboardManager.m:114</a></div></div>
<div class="ttc" id="a_x_h_x_text_keyboard_manager_8m_html_afa1e10908bab765097e7bc6686b28c40"><div class="ttname"><a href="_x_h_x_text_keyboard_manager_8m.html#afa1e10908bab765097e7bc6686b28c40">_lastIsNotification</a></div><div class="ttdeci">BOOL _lastIsNotification</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00119">XHXTextKeyboardManager.m:119</a></div></div>
<div class="ttc" id="aprotocol_x_h_x_text_keyboard_observer-p_html_a86d508f78d636624b318273a94a6104d"><div class="ttname"><a href="protocol_x_h_x_text_keyboard_observer-p.html#a86d508f78d636624b318273a94a6104d">-[XHXTextKeyboardObserver-p keyboardChangedWithTransition:]</a></div><div class="ttdeci">void keyboardChangedWithTransition:(XHXTextKeyboardTransition transition)</div></div>
<div class="ttc" id="ainterface___x_h_x_text_keyboard_view_frame_observer_html"><div class="ttname"><a href="interface___x_h_x_text_keyboard_view_frame_observer.html">_XHXTextKeyboardViewFrameObserver</a></div><div class="ttdoc">Observer for view&#39;s frame/bounds/center/transform</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_text_keyboard_manager_8m_source.html#l00035">XHXTextKeyboardManager.m:36</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>